#ifndef __KVS_VISCLIENT_LABEL_H__
#define __KVS_VISCLIENT_LABEL_H__

#include <kvs/glut/Label>
#include <kvs/glut/Screen>
#include <kvs/glut/LegendBar>
#include <kvs/RGBFormulae>
#include "Command.h"
#include "TFE_main.h"

namespace kvs
{
namespace visclient
{
class Command;

class StepLabel : public kvs::glut::Label
{
private:
    Command* command;
public:

    StepLabel( Command* command );

    void screenUpdated( void );
};

class SizeLabel : public kvs::glut::Label
{
public:

    SizeLabel( Command* command );

    void screenUpdated( void );
};

class NodesLabel : public kvs::glut::Label
{
public:

    NodesLabel( kvs::visclient::Command* command );

    void screenUpdated( void );
};


class ElementsLabel : public kvs::glut::Label
{
public:

    ElementsLabel( kvs::visclient::Command* command );

    void screenUpdated( void );
};

class FPSLabel : public kvs::glut::Label
{
private:
    const kvs::RendererBase* renderer;

public:

    FPSLabel( kvs::ScreenBase* screen, const kvs::RendererBase* renderer );

    void screenUpdated( void );
};

// 2016.1.14 Add by FEAST
class LegendBar : public kvs::glut::LegendBar
{
private:
    Command* m_command;
//            kvs::ColorMap color_map = kvs::RGBFormulae::Rainbow( 256 );
    int select_tf;

public:

    LegendBar( kvs::ScreenBase* screen, Command* command ) :
        kvs::glut::LegendBar( screen ), m_command( command )
    {
        setWidth( 200 );
        setHeight( 50 );
//				color_map.setRange(0, 1);
//				setColorMap(color_map);
    }

    void screenUpdated( void );

    void select_tfr( int i );

    void screenResized( void );

    void set_hide( void );
    void set_show( void );
};

}
}

#endif
