#ifndef __KVS_VISCLIENT_PBVR_LEGEND_PANEL_UI_H__
#define __KVS_VISCLIENT_PBVR_LEGEND_PANEL_UI_H__

#include <string>
#include <vector>
#include "Label.h"

#include "GL/glui.h"

#include "LegendFrameColor.h"
#include "LegendDivisionColor.h"

namespace kvs
{
namespace visclient
{

class LegendpanelUI
{

protected:

    kvs::ScreenBase*  m_screen; ///< pointer to screen
    GLUI_Checkbox* ch_b_legend;	// Legendのon/off
    int legend_display_val[1];	// Legendのon/off
    GLUI_EditText* tx_caption;	// キャプションの文字列
    char str_cpation[300];	// キャプションの文字列
    GLUI_RadioGroup* rdi_bar;	// バーの向き
    int bar_val;				// バーの向き
    GLUI_Panel* pn_division;	// 目盛り
    GLUI_EditText* tx_Intervals_num;		// 目盛りの数
    GLUI_Button* bt_Intervals_color;		// 目盛りの色
    GLUI_EditText* tx_Intervals_thickness;	// 目盛りの太さ
    GLUI_Panel* pn_Frameline;	// 枠線
    GLUI_Button* bt_Framelines_color;		// 枠線の色
    GLUI_EditText* bt_Frameline_thickness;	// 枠線の太さ
    GLUI_Listbox* list_colormap;	// 伝達関数の指定
    bool show_ui;              // Legendの表示／非表示
    kvs::visclient::LegendBar* m_legend;

public:

    LegendpanelUI();
    virtual ~LegendpanelUI();

    GLUI* glui_legend_main;
    void createPanel( kvs::visclient::LegendBar* m_legend, kvs::ScreenBase* parent = 0 );
    bool get_show_ui();
    void change_show_ui();
    void select_tfr();
    void set_display();
    void set_Orientation();
    void set_Division();
    void set_Division_Thickness();
    void set_Division_Color();
    void set_Franeline_Thickness();
    void set_Franeline_Color();
    void set_Caption();
    void colsePanel();
    void show_LegendFrameColor();
    void show_LegendDivisionColor();

    kvs::visclient::Legend_Frame_Color* m_lfc;
    kvs::visclient::Legend_Division_Color* m_ldc;
};

} // namespace visclient
} // namespace kvs

#endif // __KVS_VISCLIENT_PBVR_LEGEND_PANEL_UI_IH__
