#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdlib>
#include <string.h>
#include <map>

#include "ParamInfo.h"

bool ParamInfo::LoadIN( const std::string& filename )
{
    std::ifstream fin( filename.c_str(), std::ios::in );
    std::string name;
    std::string value;
    std::string equal;
    if ( !fin.is_open() )
    {
        std::cerr << "Cannot open " << filename << std::endl;
        fin.close();
        return false;
    }

    std::string line;

    param_state.insert( std::map<std::string, bool>::value_type( "sub_pixel_level" , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "repeat_level"    , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "crop_region_0"   , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "crop_region_1"   , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "crop_region_2"   , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "crop_region_3"   , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "crop_region_4"   , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "crop_region_5"   , false ) );

    param_state.insert( std::map<std::string, bool>::value_type( "t1"   , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "t2"   , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "t3"   , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "t4"   , false ) );
    param_state.insert( std::map<std::string, bool>::value_type( "t5"   , false ) );

    while ( std::getline( fin, line ) )
    {
        size_t pos;
        while ( ( pos = line.find_first_of( " 　\t\r\n" ) ) != std::string::npos )
        {
            line.erase( pos, 1 );
        }

        if ( ( pos = line.find_first_of( "=" ) ) != std::string::npos )
        {
            name = line.substr( 0, pos );
            value = line.substr( pos + 1 );
        }
        else
        {
            name = "";
        }

        std::string key = "";
//        if( !strcmp( name.c_str(),"SUB_PIXEL_LEVEL_DETAILED" ) )   key = "sub_pixel_level";
        if ( !strcmp( name.c_str(), "SUB_PIXEL_LEVEL" ) )   key = "sub_pixel_level";
//        else if( !strcmp( name.c_str(),"REPEAT_LEVEL_DETAILED" ) ) key = "repeat_level";
        else if ( !strcmp( name.c_str(), "REPEAT_LEVEL" ) ) key = "repeat_level";
        else if ( !strcmp( name.c_str(), "CROP_CXMIN" ) )            key = "crop_region_0";
        else if ( !strcmp( name.c_str(), "CROP_CYMIN" ) )            key = "crop_region_1";
        else if ( !strcmp( name.c_str(), "CROP_CZMIN" ) )            key = "crop_region_2";
        else if ( !strcmp( name.c_str(), "CROP_CXMAX" ) )            key = "crop_region_3";
        else if ( !strcmp( name.c_str(), "CROP_CYMAX" ) )            key = "crop_region_4";
        else if ( !strcmp( name.c_str(), "CROP_CZMAX" ) )            key = "crop_region_5";
        else if ( !strcmp( name.c_str(), "TF_RESOLUTION" ) )         key = "tf_resolution";
        else if ( !strcmp( name.c_str(), "TF_SYNTH" ) )              key = "tf_synthesis";
        else if ( name == "TF_NAME1_VAR_C"   ) key = name;
        else if ( name == "TF_NAME1_MIN_C"   ) key = name;
        else if ( name == "TF_NAME1_MAX_C"   ) key = name;
        else if ( name == "TF_NAME1_VAR_O"   ) key = name;
        else if ( name == "TF_NAME1_MIN_O"   ) key = name;
        else if ( name == "TF_NAME1_MAX_O"   ) key = name;
        else if ( name == "TF_NAME1_TABLE_C" ) key = name;
        else if ( name == "TF_NAME1_TABLE_O" ) key = name;
        else if ( name == "TF_NAME2_VAR_C"   ) key = name;
        else if ( name == "TF_NAME2_MIN_C"   ) key = name;
        else if ( name == "TF_NAME2_MAX_C"   ) key = name;
        else if ( name == "TF_NAME2_VAR_O"   ) key = name;
        else if ( name == "TF_NAME2_MIN_O"   ) key = name;
        else if ( name == "TF_NAME2_MAX_O"   ) key = name;
        else if ( name == "TF_NAME2_TABLE_C" ) key = name;
        else if ( name == "TF_NAME2_TABLE_O" ) key = name;
        else if ( name == "TF_NAME3_VAR_C"   ) key = name;
        else if ( name == "TF_NAME3_MIN_C"   ) key = name;
        else if ( name == "TF_NAME3_MAX_C"   ) key = name;
        else if ( name == "TF_NAME3_VAR_O"   ) key = name;
        else if ( name == "TF_NAME3_MIN_O"   ) key = name;
        else if ( name == "TF_NAME3_MAX_O"   ) key = name;
        else if ( name == "TF_NAME3_TABLE_C" ) key = name;
        else if ( name == "TF_NAME3_TABLE_O" ) key = name;
        else if ( name == "TF_NAME4_VAR_C"   ) key = name;
        else if ( name == "TF_NAME4_MIN_C"   ) key = name;
        else if ( name == "TF_NAME4_MAX_C"   ) key = name;
        else if ( name == "TF_NAME4_VAR_O"   ) key = name;
        else if ( name == "TF_NAME4_MIN_O"   ) key = name;
        else if ( name == "TF_NAME4_MAX_O"   ) key = name;
        else if ( name == "TF_NAME4_TABLE_C" ) key = name;
        else if ( name == "TF_NAME4_TABLE_O" ) key = name;
        else if ( name == "TF_NAME5_VAR_C"   ) key = name;
        else if ( name == "TF_NAME5_MIN_C"   ) key = name;
        else if ( name == "TF_NAME5_MAX_C"   ) key = name;
        else if ( name == "TF_NAME5_VAR_O"   ) key = name;
        else if ( name == "TF_NAME5_MIN_O"   ) key = name;
        else if ( name == "TF_NAME5_MAX_O"   ) key = name;
        else if ( name == "TF_NAME5_TABLE_C" ) key = name;
        else if ( name == "TF_NAME5_TABLE_O" ) key = name;
        else
        {
            for ( int i = 1; i <= 5; i++ )
            {
                std::string num;
                std::stringstream ss;
                ss << i;
                num = ss.str();

                if ( !strcmp( name.c_str(), std::string( "T" + num + "_R" ).c_str() ) )   key = "t" + num + "_r";
                else if ( !strcmp( name.c_str(), std::string( "T" + num + "_G" ).c_str() ) )   key = "t" + num + "_g";
                else if ( !strcmp( name.c_str(), std::string( "T" + num + "_B" ).c_str() ) )   key = "t" + num + "_b";
                else if ( !strcmp( name.c_str(), std::string( "T" + num + "_A" ).c_str() ) )   key = "t" + num + "_a";
                if ( key != "" )
                {
                    param_state["t" + num] = true;
                    break;
                }
            }

            for ( int i = 1; i <= 5; i++ )
            {
                std::string num;
                std::stringstream ss;
                ss << i;
                num = ss.str();
                if ( !strcmp( name.c_str(), std::string( "T" + num + "_VAR" ).c_str() ) ) key = "t" + num + "_var";
                else if ( !strcmp( name.c_str(), std::string( "T" + num + "_MIN" ).c_str() ) ) key = "t" + num + "_min";
                else if ( !strcmp( name.c_str(), std::string( "T" + num + "_MAX" ).c_str() ) ) key = "t" + num + "_max";
            }
        }

        if ( key != "" )
        {
            param.insert( std::map<std::string, std::string>::value_type( key, value ) );
            param_state[key] = true;
        }
    }

    return true;
}

size_t ParamInfo::get_subpixel_level()
{
    return std::atoi( param["sub_pixel_level"].c_str() );
}

size_t ParamInfo::get_repeat_level()
{
    return std::atoi( param["repeat_level"].c_str() );
}

float ParamInfo::get_crop_region( int index )
{
    float value;
    if (      index == 0 ) value = std::atof( param["crop_region_0"].c_str() );
    else if ( index == 1 ) value = std::atof( param["crop_region_1"].c_str() );
    else if ( index == 2 ) value = std::atof( param["crop_region_2"].c_str() );
    else if ( index == 3 ) value = std::atof( param["crop_region_3"].c_str() );
    else if ( index == 4 ) value = std::atof( param["crop_region_4"].c_str() );
    else if ( index == 5 ) value = std::atof( param["crop_region_5"].c_str() );
    else                 value = 0.0;

    return ( value );
}

int ParamInfo::getInt( std::string name )
{
    return std::atoi( param[name].c_str() );
}

float ParamInfo::getFloat( std::string name )
{
    return std::atof( param[name].c_str() );
}

std::string ParamInfo::getString( std::string name )
{
    if ( param.find( name ) == param.end() )
        return "";
    else
        return param[name];
}
