#include <algorithm>
#include <kvs/Directory>
#include <kvs/File>
#include <kvs/PointImporter>
#include <kvs/PointExporter>
#include <kvs/KVSMLObjectPoint>
#include "ParticleMerger.h"
#include "ParticleMergerUI.h"
#include "KVSMLObjectPointWriter.h"

extern void cbParticlpanel_sw( int i );

namespace
{
kvs::visclient::ParticleMergerUI* pparticle_mui;

void cb_paricle_add( int id )
{
    pparticle_mui->particle_add_func();
}
void cb_paricle_delete( int id )
{
    pparticle_mui->particle_delet_func();
}
void cb_paricle_File_active( int id )
{
    pparticle_mui->particle_file_active_func();
}
void cb_paricle_File_close( int id )
{
    pparticle_mui->particle_file_close_func();
}
void cb_paricle_browse_dir( int id )
{
    pparticle_mui->paricle_browse_dir_active_func();
}
void cb_paricle_browse_file( int id )
{
    pparticle_mui->paricle_browse_file_active_func();
}
void cb_paricle_export( int id )
{
    pparticle_mui->paricle_export_do_func();
}
void cb_paricle_display_val( int id )
{
    pparticle_mui->paricle_changed_flag();
}
void cb_paricle_panel_close( int id )
{
    cbParticlpanel_sw( 1 );
}
} // end of namespace

namespace kvs
{
namespace visclient
{

ParticleMergerUI::ParticleMergerUI()
{
    static int tmpKeepInitial_val[11] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    static int tmpKeepFinal_val[11]  = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
    static int tmpparticle_val[11] = {1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
    for ( int i = 0; i < 11; i++ )
    {
        KeepInitial_val[i] = tmpKeepInitial_val[i];
        KeepFinal_val[i] = tmpKeepFinal_val[i];
        particle_val[i] = tmpparticle_val[i];
        if ( filepath_strings[i].empty() != false )
        {
            filepath_strings[i].clear();
        }
        filepath_changed[i] = false;
    }
    filepath_strings[0] = "server";
    total_item = 0;
    doExport = false;
    start_Export_time = -1;

    fd_file = NULL;
    fd_dir = NULL;

    changed = false;
}

ParticleMergerUI::~ParticleMergerUI()
{
}

void ParticleMergerUI::createPanel( int CSmode, kvs::visclient::ParticleMergeParam* param ) //CSmode=1 はサーバ通信モード
{
    pparticle_mui = this;

    glui_particle_main = GLUI_Master.create_glui( "Particle panel", 0, 800, 100 );
    main_Particle = glui_particle_main->add_panel( "", GLUI_PANEL_NONE );
    // クライアントが読み込む粒子一覧の表示
    pn_display = glui_particle_main->add_panel_to_panel( main_Particle, "Display Particle", GLUI_PANEL_EMBOSSED );
    if ( CSmode == 0 )
    {
        *particle_val = 0; // スタンドアローンモードならserver欄のチェックは外す
    }
    ch_b_particle[0] = glui_particle_main->add_checkbox_to_panel( pn_display, "Server", particle_val, 0, cb_paricle_display_val );
    // スタンドアローンモードならserver欄は不活性
    if ( CSmode == 0 )
    {
        ch_b_particle[0]->disable();
    }
    char buf[64];
    for ( int i = 1; i < 11; i++ )
    {
        sprintf( buf, "(Particle%d)", i ); // Particle文字列で初期化
        ch_b_particle[i] = glui_particle_main->add_checkbox_to_panel( pn_display, buf, particle_val + i, 1, cb_paricle_display_val );
        item_strings[i].append( buf );
    }
    for ( int i = 1; i < 11; i++ )
    {
        ch_b_particle[i]->disable(); // 不活性
    }

    // 前方補間
    glui_particle_main->add_column_to_panel( main_Particle, false );
    GLUI_Panel* pn_KeepInitial = glui_particle_main->add_panel_to_panel( main_Particle, "Keep Initial Step", GLUI_PANEL_EMBOSSED );
    ch_b_KeepInitial[0] = glui_particle_main->add_checkbox_to_panel( pn_KeepInitial, "Server", KeepInitial_val );
    // スタンドアローンモードならserver欄は不活性
    if ( CSmode == 0 )
    {
        ch_b_KeepInitial[0]->disable();
    }
    for ( int i = 1; i < 11; i++ )
    {
        sprintf( buf, "(Particle%d)", i );
        ch_b_KeepInitial[i] = glui_particle_main->add_checkbox_to_panel( pn_KeepInitial, buf, KeepInitial_val + i );
    }
    for ( int i = 1; i < 11; i++ )
    {
        ch_b_KeepInitial[i]->disable();
    }

    // 後方補間
    glui_particle_main->add_column_to_panel( main_Particle, false );
    GLUI_Panel* pn_KeepFinal = glui_particle_main->add_panel_to_panel( main_Particle, "Keep Final Step", GLUI_PANEL_EMBOSSED );
    ch_b_KeepFinal[0] = glui_particle_main->add_checkbox_to_panel( pn_KeepFinal, "Server", KeepFinal_val );
    for ( int i = 1; i < 11; i++ )
    {
        sprintf( buf, "(Particle%d)", i );
        ch_b_KeepFinal[i] = glui_particle_main->add_checkbox_to_panel( pn_KeepFinal, buf, KeepFinal_val + i );
    }
    // スタンドアローンモードならserver欄は不活性
    if ( CSmode == 0 )
    {
        ch_b_KeepFinal[0]->disable();
    }
    for ( int i = 1; i < 11; i++ )
    {
        ch_b_KeepFinal[i]->disable();
    }

    glui_particle_main->add_button( "Particle File (Add/Export)", -1, cb_paricle_File_active );
    pn_Del = glui_particle_main->add_panel( "Delete Particle" );
    list_del = glui_particle_main->add_listbox_to_panel( pn_Del, "Delete Item" );
    int total_cnt = 0;
    for ( int i = 1; i < 11; i++ )
    {
        if ( ch_b_particle[i]->enabled )
        {
            list_del->add_item( i, ch_b_particle[i]->name.c_str() );
            total_cnt++;
        }
    }
    bott_del = glui_particle_main->add_button_to_panel( pn_Del, "Delete", -1, cb_paricle_delete );
    if ( total_cnt == 0 )
    {
        list_del->disable();
        bott_del->disable();
    }
    glui_add_del = GLUI_Master.create_glui( "Particle File", 0, 900, 200 );
    pn_Add = glui_add_del->add_panel( "Add Particle" );
    list_add = glui_add_del->add_listbox_to_panel( pn_Add, "Add Item" );
    list_add->set_int_val( 1 );
    pn_FileB1 = glui_add_del->add_panel_to_panel( pn_Add, NULL, GLUI_PANEL_NONE );
    text_filepath = glui_add_del->add_edittext_to_panel( pn_FileB1, "File path:", GLUI_EDITTEXT_TEXT, NULL );
    text_filepath->set_w( 300 );
    glui_add_del->add_column_to_panel( pn_FileB1, false );
    bott_dir_fd = glui_add_del->add_button_to_panel( pn_FileB1, "Browse...", -1, cb_paricle_browse_dir );
    text_partiname = glui_add_del->add_edittext_to_panel( pn_Add, "Particle name(Optional):", GLUI_EDITTEXT_TEXT
                                                          , NULL );
    text_partiname->set_w( 250 );
    glui_add_del->add_button_to_panel( pn_Add, "Add", -1, cb_paricle_add );
    // ------
    pn_Output = glui_add_del->add_panel( "Export Particle" );
    pn_FileB2 = glui_add_del->add_panel_to_panel( pn_Output, NULL, GLUI_PANEL_NONE );
    text_output_filepath = glui_add_del->add_edittext_to_panel( pn_FileB2, "File path:", 1, NULL );
    text_output_filepath->set_w( 300 );
    glui_add_del->add_column_to_panel( pn_FileB2, false );
    bott_filepath_fd = glui_add_del->add_button_to_panel( pn_FileB2, "Browse...", -1, cb_paricle_browse_file );
    bott_export = glui_add_del->add_button_to_panel( pn_Output, "Export", -1, cb_paricle_export );

    glui_add_del->add_button( "Close", -1, cb_paricle_File_close );
    glui_add_del->hide();

    // pinオプションの考慮
    for ( int i = 0; i < 10; i++ )
    {
        if ( param->particles[i + 1].filepath.empty() != true )
        {

            // ディレクトリを登録
            total_item++;
            filepath_strings[i + 1].clear();
            filepath_strings[i + 1].append( param->particles[i + 1].filepath );

            // ディレクトリ名でリストに追加
            std::string buffdir( param->particles[i + 1].filepath );
            if ( buffdir[buffdir.size() - 1] == kvs::Directory::Separator()[0] )
            {
                // パスの指定の最後が/ならば削除しておく
                buffdir.erase( buffdir.size() - 1, 1 );
            }
            if ( buffdir.find_last_of( kvs::Directory::Separator() ) != std::string::npos )
            {
                // 上の階層のパスは削除
                buffdir.erase( 0, buffdir.find_last_of( kvs::Directory::Separator() ) + 1 );
            }
            ch_b_particle[i + 1]->set_name( buffdir.c_str() );
            ch_b_KeepInitial[i + 1]->set_name( buffdir.c_str() );
            ch_b_KeepFinal[i + 1]->set_name( buffdir.c_str() );
            // 操作可能にする
            ch_b_particle[i + 1]->enable();
            ch_b_KeepInitial[i + 1]->enable();
            ch_b_KeepFinal[i + 1]->enable();
            // 削除リストに追加
            list_del->add_item( i + 1, buffdir.c_str() );

            item_strings[i + 1].erase( 0 );
            item_strings[i + 1].append( buffdir.c_str() );

            //チェックを有効化.
            ch_b_particle[i + 1]->set_int_val( 1 );
            particle_val[i + 1] = 1;
            changed = 1;
            list_add->add_item( i + 1, buffdir.c_str() );
        }
        else
        {
            list_add->add_item( i + 1, ch_b_particle[i + 1]->name.c_str() );
        }
    }
    if ( total_item > 0 )
    {
        bott_del->enable();
        list_del->enable();
    }

    glui_particle_main->add_button( "Close", -1, cb_paricle_panel_close );
    glui_particle_main->hide();
    show_pui = false;
}

void ParticleMergerUI::particle_file_active_func()
{
    glui_add_del->show();
}

void ParticleMergerUI::particle_file_close_func()
{
    glui_add_del->hide();
}

void ParticleMergerUI::paricle_browse_dir_active_func()
{
    glui_particele_file = GLUI_Master.create_glui( "FileDialog" );
    fd_file = new FileDialog( glui_particele_file, bott_dir_fd, 0, text_filepath->get_text(), text_filepath );
}

void ParticleMergerUI::paricle_browse_file_active_func()
{
    glui_particele_file = GLUI_Master.create_glui( "FileDialog" );
    fd_file = new FileDialog( glui_particele_file, bott_filepath_fd, 0, text_output_filepath->get_text(), text_output_filepath );
}

void ParticleMergerUI::paricle_export_do_func()
{
    int check = 0;
    // 表示しているものがあるか確認
    for ( int i = 0; i < 11; i++ )
    {
        if ( particle_val[i] == 1 )
        {
            check = 1;
        }
    }

    // 表示しているものがあれば粒子出力をする
    if ( check == 1 )
    {
        // Exportボタンを不活性に切り替える
        bott_export->disable();
        // flagを立てる
        doExport = true;
    }
}

void ParticleMergerUI::setParam( kvs::visclient::ParticleMergeParam* param )
{
    printf( "In func ParticleMergerUI::setParam\n" );
    m_param = param;
    // 粒子の統合情報を設定
    for ( int i = 1; i < 11; i++ )
    {
        // 表示、非表示のフラグを設定
        if ( particle_val[i] == 1 )
        {
            m_param->particles[i].enable = true;
        }
        else
        {
            m_param->particles[i].enable = false;
        }
        // 粒子ファイルのパスを設定。ただし未設定の場合、表示フラグはfalseにする
        if ( filepath_strings[i].empty() != true )
        {
            printf( "Set filepat\n" );
            printf( "Input filepath %s\n", filepath_strings[i].c_str() );
            m_param->particles[i].filepath.clear();
            m_param->particles[i].filepath.append( filepath_strings[i] );
            printf( "Input filepath %s\n", m_param->particles[i].filepath.c_str() );
        }
        else
        {
            m_param->particles[i].enable = false;
            m_param->particles[i].filepath.clear();
        }
    }
    // 先頭のリストについてチェック
    if ( particle_val[0] == 1 )
    {
        m_param->particles[0].enable = true;
        m_param->particles[0].filepath = filepath_strings[0];
    }
    else
    {
        m_param->particles[0].enable = false;
    }

    for ( int i = 0; i < 11; i++ )
    {
        m_param->particles[i].keep_initial_step = KeepInitial_val[i];
        m_param->particles[i].keep_final_step   = KeepFinal_val[i];
    }

    // Exportが押された時の処理
    if ( doExport )
    {
        if ( text_output_filepath->get_text() != NULL )
        {
            // Exportフラグを設定
            m_param->doExport = true;
            // 粒子の出力情報を設定
            m_param->export_filepath.clear();
            m_param->export_filepath.append( text_output_filepath->get_text() );
            // 出力時刻を記録（実際には書き出し１つ前の時刻）
            start_Export_time = m_param->crt_time;
            // Exportが押された時のフラグを元に戻す
            doExport = false;
        }
    }
    /*
        else{
    	// 出力中の確認
    	if(m_param->doExport){ // 出力中
    	    if(start_Export_time == m_param->crt_time){ // 出力時間が一周した
    		m_param->doExport = false; // 出力を止める
    		bott_export->enable(); // ボタンを操作可能に戻す
    	    }
    	}
        }
    */
    printf( "End ParticleMergerUI::setParam\n" );
}

void ParticleMergerUI::paricle_export_bottom_active()
{
    // Exportボタンを操作可能に戻す
    bott_export->enable();
}

void ParticleMergerUI::paricle_changed_flag()
{
    // ビュー正規化用にflagを立てる
    changed = true;
}

void ParticleMergerUI::paricle_reset_changed_flag()
{
    changed = false;
}

bool ParticleMergerUI::check_chenge_flag()
{
    return changed;
}

void ParticleMergerUI::particle_add_func()
{
    printf( "In func particle_add_func \n" );
    int item_num = list_add->get_int_val();
    int flag = 0;

    if ( text_filepath->get_text() != NULL )
    {
        filepath_strings[item_num].clear();
        filepath_strings[item_num].append( text_filepath->get_text() );
        printf( "Set filepath : %s\n", filepath_strings[item_num].c_str() );
    }

    if ( text_partiname->get_text() != NULL && text_filepath->get_text() != NULL )
    {
        if ( strlen( text_partiname->get_text() ) > 0 )
        {
            // 削除リストを初期化
            for ( int i = 0; i < 11; i++ )
            {
                list_del->delete_item( i );
            }
            total_item++;
            // パーティクルをリストに追加
            printf( "get particle name !!!!!! (%s)\n", text_partiname->get_text() );
            // ユーザ指定の名前でリストに追加
            ch_b_particle[item_num]->set_name( text_partiname->get_text() );
            ch_b_KeepInitial[item_num]->set_name( text_partiname->get_text() );
            ch_b_KeepFinal[item_num]->set_name( text_partiname->get_text() );
            item_strings[item_num].erase( 0 );
            item_strings[item_num].append( text_partiname->get_text() );
            flag = 1;
        }
    }
    if ( flag == 0 && text_filepath->get_text() != NULL )
    {
        if ( strlen( text_filepath->get_text() ) > 0 )
        {
            // 削除リストを初期化
            for ( int i = 0; i < 11; i++ )
            {
                list_del->delete_item( i );
            }
            total_item++;
            // ディレクトリ名でリストに追加
            std::string buffdir( text_filepath->get_text() );
            if ( buffdir[buffdir.size() - 1] == kvs::Directory::Separator()[0] )
            {
                // パスの指定の最後が/ならば削除しておく
                printf( "erase last / \n" );
                buffdir.erase( buffdir.size() - 1, 1 );
            }
            printf( "check / \n" );
            // '/'が存在するか確認をする
            if ( buffdir.find_last_of( kvs::Directory::Separator() ) != std::string::npos )
            {
                // 上の階層のパスは削除
                buffdir.erase( 0, buffdir.find_last_of( kvs::Directory::Separator() ) + 1 );
            }
            ch_b_particle[item_num]->set_name( buffdir.c_str() );
            ch_b_KeepInitial[item_num]->set_name( buffdir.c_str() );
            ch_b_KeepFinal[item_num]->set_name( buffdir.c_str() );
            item_strings[item_num].erase( 0 );
            item_strings[item_num].append( buffdir.c_str() );

            flag = 1;
        }
    }

    if ( flag == 1 )
    {
        // 操作可能にする
        ch_b_particle[item_num]->enable();
        ch_b_KeepInitial[item_num]->enable();
        ch_b_KeepFinal[item_num]->enable();

        // 削除リストに追加
        for ( int i = 1; i < 11; i++ )
        {
            size_t loc = item_strings[i].find( "(Particle", 0 );
            if ( loc == std::string::npos )
            {
                list_del->add_item( i, item_strings[i].c_str() );
            }
        }

        // addリストに追加
        for ( int i = 1; i < 11; i++ )
        {
            list_add->delete_item( i );
        }
        for ( int i = 1; i < 11; i++ )
        {
            list_add->add_item( i, ch_b_particle[i]->name.c_str() );
        }
        bott_del->enable();
        list_del->enable();
    }
    printf( "End particle_add_func.\n" );
}

void ParticleMergerUI::particle_delet_func()
{
    printf( "In particle_delet_func\n" );
    int item_num = list_del->get_int_val();
    GLUI_Listbox_Item* pitem = list_del->get_item_ptr( item_num );
    if ( pitem != NULL )
    {
        printf( "delete item %s.(%d)\n", pitem->text.c_str(), item_num );
        if ( particle_val[item_num] != 0 )
        {
            paricle_changed_flag(); // 表示されていたものが消えるのでViewerの初期化
        }
        // パーティクルをリストをParticleに戻す
        char buf[64];
        sprintf( buf, "(Particle%d)", item_num );
        ch_b_particle[item_num]->set_name( buf );
        ch_b_KeepInitial[item_num]->set_name( buf );
        ch_b_KeepFinal[item_num]->set_name( buf );
        // 内部テーブルも初期化
        item_strings[item_num].erase( 0 );
        item_strings[item_num].append( buf );
        filepath_strings[item_num].clear();
        // チェックを外す
        ch_b_particle[item_num]->set_int_val( 0 );
        ch_b_KeepInitial[item_num]->set_int_val( 0 );
        ch_b_KeepFinal[item_num]->set_int_val( 0 );
        // 操作不可能にする
        ch_b_particle[item_num]->disable();
        ch_b_KeepInitial[item_num]->disable();
        ch_b_KeepFinal[item_num]->disable();
        total_item--;
        // 削除リストを初期化
        for ( int i = 0; i < 11; i++ )
        {
            list_del->delete_item( i );
        }
        // 削除リストを更新
        for ( int i = 1; i < 11; i++ )
        {
            size_t loc = item_strings[i].find( "(Particle", 0 );
            printf( "item = %s %d\n", item_strings[i].c_str(), loc );
            if ( loc == std::string::npos )
            {
                list_del->add_item( i, item_strings[i].c_str() );
            }
        }
        // addリストを初期化
        for ( int i = 1; i < 11; i++ )
        {
            list_add->delete_item( i );
        }
        // addリストを更新
        for ( int i = 1; i < 11; i++ )
        {
            list_add->add_item( i, ch_b_particle[i]->name.c_str() );
        }
    }
    if ( total_item == 0 )
    {
        bott_del->disable();
        list_del->disable();
    }
}

bool ParticleMergerUI::get_show_pui()
{
    return show_pui;
}

void ParticleMergerUI::change_show_pui()
{
    show_pui = ! show_pui;
}

} // namespace visclient
} // namespace kvs

