#ifndef __KVS_VISCLIENT_PBVR_PARTICLE_MERGER_UI_H__
#define __KVS_VISCLIENT_PBVR_PARTICLE_MERGER_UI_H__

#include <string>
#include <vector>
#include <kvs/PointObject>
#include "ParticleMergeParam.h"
#include "FileDialog.h"

#include "GL/glui.h"


namespace kvs
{
namespace visclient
{
class ParticleMergerParam;

class ParticleMergerUI
{

//protected:
public:

    kvs::visclient::ParticleMergeParam* m_param;
    int total_item;
    std::string item_strings[11];
    std::string filepath_strings[11];
    int KeepInitial_val[11];
    int KeepFinal_val[11];
    int particle_val[11];
    bool filepath_changed[11];
    bool doExport;
    int start_Export_time;
    GLUI* glui_particle_main;
    GLUI* glui_add_del;
    GLUI* glui_particele_file;
    GLUI* glui_particele_dir;

    GLUI_Panel* main_Particle;
    GLUI_Panel* pn_display;
    GLUI_Panel* pn_KeepInitial;
    GLUI_Panel* pn_KeepFinal;
    GLUI_Panel* pn_Del;
    GLUI_Listbox* list_del;
    GLUI_Button* bott_del;

    GLUI_Checkbox* ch_b_particle[11];
    GLUI_Checkbox* ch_b_KeepInitial[11];
    GLUI_Checkbox* ch_b_KeepFinal[11];

    GLUI_Panel* pn_Add;
    GLUI_Listbox* list_add;
    GLUI_Panel* pn_FileB1;
    GLUI_EditText* text_filepath;
    GLUI_EditText* text_partiname;
    GLUI_Button* bott_dir_fd;
    GLUI_Panel* pn_Output;
    GLUI_Panel* pn_FileB2;
    GLUI_EditText* text_output_filepath;
    GLUI_Button* bott_filepath_fd;
    GLUI_Button* bott_export;

    FileDialog* fd_file;
    FileDialog* fd_dir;

    // 粒子の表示ボタンのon/offが変化した場合 true になる（正規化用）
    bool changed;

    bool show_pui;

public:

    ParticleMergerUI();
    virtual ~ParticleMergerUI();

    void setParam( kvs::visclient::ParticleMergeParam* param );
    void setArgParam();
    void createPanel( int CSmode = 0, kvs::visclient::ParticleMergeParam* param = NULL );

    void particle_add_func();
    void particle_delet_func();
    void particle_file_active_func();
    void particle_file_close_func();
    void paricle_browse_dir_active_func();
    void paricle_browse_file_active_func();
    void paricle_export_do_func();
    void paricle_export_bottom_active();
    void paricle_changed_flag();
    void paricle_reset_changed_flag();
    bool check_chenge_flag();
    bool get_show_pui();
    void change_show_pui();
    void paricle_panel_close();
};

} // namespace visclient
} // namespace kvs

#endif // __KVS_VISCLIENT_PBVR_PARTICLE_MERGER_UI_IH__

