#include <fstream>

#include "GL/glui.h"
#define GL_GPU_MEM_INFO_TOTAL_AVAILABLE_MEM_NVX 0x9048
#define GL_GPU_MEM_INFO_CURRENT_AVAILABLE_MEM_NVX 0x9049

#define SUB_PIXEL_LEVEL_ABSTRACT  2
#define SUB_PIXEL_LEVEL_DETAILED  2
#define REPEAT_LEVEL_ABSTRACT  1
//#define REPEAT_LEVEL_DETAILED 16
#define REPEAT_LEVEL_DETAILED 1 /* change 2014.07.21 */
#define PARTICLE_LIMIT 10000000 /* change 1 to 10 2015.03.26 */
#define PARTICLE_DENSITY 1.0f

#define LOOKAT_EYEX_LEVEL 0.0F
#define LOOKAT_EYEY_LEVEL 0.0F
#define LOOKAT_EYEZ_LEVEL 0.0F
#define LOOKAT_CENTERX_LEVEL 0.0F
#define LOOKAT_CENTERY_LEVEL 0.0F
#define LOOKAT_CENTERZ_LEVEL 0.0F
#define LOOKAT_UPVECTORX_LEVEL 0.0F
#define LOOKAT_UPVECTORY_LEVEL 1.0F
#define LOOKAT_UPVECTORZ_LEVEL 0.0F
// APPEND START FP)K.YAJIMA 2015.02.27
#define RESOLUTIONWIDTH_LEVEL 620.0F
#define RESOLUTIONHEIGHT_LEVEL 620.0F
// APPEND END FP)K.YAJIMA 2015.02.27
#define RESOLUTIONHEIGHT_DEVICE 900

#define CX_MAX_LEVEL 0.0F
#define CX_MIN_LEVEL 0.0F
#define CY_MAX_LEVEL 0.0F
#define CY_MIN_LEVEL 0.0F
#define CZ_MAX_LEVEL 0.0F
#define CZ_MIN_LEVEL 0.0F

#include "CropParam.h"
#define CROP_CXMIN 1.0
#define CROP_CXMAX 1.0
#define CROP_CYMIN 1.0
#define CROP_CYMAX 1.0
#define CROP_CZMIN 1.0
#define CROP_CZMAX 1.0

#define DATAFILE "data"  // /tmp/data_20140311101010.dat
#define LIMITDATAFILE "limit" // /tmp/limit.dat
#define DOCK_H 40  // for right or left Dock of Mac and Linux
//#define DOCK_H 132 // for bottom Dock of Mac
#define I_H_OFFSET 55

void cbTFEpanel_sw( int i );
void cbParticlpanel_sw( int i );
void cbAnimationpanel_sw( int i );
void cbLagendpanel_sw( int i );

void cbsubpixellevela( int i );
void cbsubpixelleveld( int i );
void cbrepeatlevela( int i );
void cbrepeatleveld( int i );
void cbplimitlevel( int i );
void cbpdensitylevel( int i );
void cbworkdir( int i );
void cbvolumedata( int i );
void cbparallellevel( int i );
void cbgpucpumode( int i );
void cbaminlevel( int i );
void cbamaxlevel( int i );
void cblookat_eyex( int i );
void cblookat_eyey( int i );
void cblookat_eyez( int i );
void cblookat_centerx( int i );
void cblookat_centery( int i );
void cblookat_centerz( int i );
void cblookat_upvectorx( int i );
void cblookat_upvectory( int i );
void cblookat_upvectorz( int i );
// APPEND START FP)K.YAJIMA 2015.03.02
void cbresolutionwidth( int i );
void cbresolutionheight( int i );
// APPEND END FP)K.YAJIMA 2015.03.02
void cbcxminlevel( int i );
void cbcxmaxlevel( int i );
void cbcyminlevel( int i );
void cbcymaxlevel( int i );
void cbczminlevel( int i );
void cbczmaxlevel( int i );
void cbcapture( int i );
void cbcapturefile( int i );
void cbapply( int i );
void cbparamfile( int i );
// tantantan
void cbreadfile( int i );
// tantantan
void init_panel();

using kvs::visclient::CropParam;
void setCropParam( CropParam* param );
CropParam* getCropParam();

#ifdef WIN32
char buff_paramfile[100] = "param.in";
char buff_capfile[100] = "c:\\temp\\hogehoge.bmp";
char buff_workdir[100] = ".";
#else
char buff_paramfile[100] = "./param.in";
char buff_capfile[100] = "/tmp/hogehoge.bmp";
char buff_workdir[100] = "/tmp";
#endif
char data_filename[100];
char limitdata_filename[100];
//int data_cnt = 0;
bool data_output = false;

int subpixellevela = SUB_PIXEL_LEVEL_ABSTRACT;
int subpixelleveld = SUB_PIXEL_LEVEL_DETAILED;
int repeatlevela = REPEAT_LEVEL_ABSTRACT;
int repeatleveld = REPEAT_LEVEL_DETAILED;
int plimitlevel = PARTICLE_LIMIT;
float pdensitylevel = PARTICLE_DENSITY;
// APPEND START FP 2015.02.27
// APPEND START BY)M.Tanaka 2015.03.11
int samplingtypelevel = 1;
int detailedparticletransfertypelevel = 1;
char shadinglevel[256] = "";
// APPEND END   BY)M.Tanaka 2015.03.11
char pfi_path_server[256];
// APPEND END   FP 2015.02.27
int wk_subpixellevela = SUB_PIXEL_LEVEL_ABSTRACT;
int wk_subpixelleveld = SUB_PIXEL_LEVEL_DETAILED;
int wk_repeatlevela = REPEAT_LEVEL_ABSTRACT;
int wk_repeatleveld = REPEAT_LEVEL_DETAILED;
int wk_plimitlevel = PARTICLE_LIMIT;
float wk_pdensitylevel = PARTICLE_DENSITY;


float cxmaxlevel = CX_MAX_LEVEL;
float cxminlevel = CX_MIN_LEVEL;
float cymaxlevel = CY_MAX_LEVEL;
float cyminlevel = CY_MIN_LEVEL;
float czmaxlevel = CZ_MAX_LEVEL;
float czminlevel = CZ_MIN_LEVEL;

float wk_cxmaxlevel = CX_MAX_LEVEL;
float wk_cxminlevel = CX_MIN_LEVEL;
float wk_cymaxlevel = CY_MAX_LEVEL;
float wk_cyminlevel = CY_MIN_LEVEL;
float wk_czmaxlevel = CZ_MAX_LEVEL;
float wk_czminlevel = CZ_MIN_LEVEL;


float lookat_eyex_level = LOOKAT_EYEX_LEVEL;
float lookat_eyey_level = LOOKAT_EYEY_LEVEL;
float lookat_eyez_level = LOOKAT_EYEZ_LEVEL;
float lookat_centerx_level = LOOKAT_CENTERX_LEVEL;
float lookat_centery_level = LOOKAT_CENTERY_LEVEL;
float lookat_centerz_level = LOOKAT_CENTERZ_LEVEL;
float lookat_upvectorx_level = LOOKAT_UPVECTORX_LEVEL;
float lookat_upvectory_level = LOOKAT_UPVECTORY_LEVEL;
float lookat_upvectorz_level = LOOKAT_UPVECTORZ_LEVEL;
// APPEND START FP)K.YAJIMA 2015.02.27
float resolution_width_level = RESOLUTIONWIDTH_LEVEL;
float resolution_height_level = RESOLUTIONHEIGHT_LEVEL;
// APPEND END FP)K.YAJIMA 2015.02.27
int resolution_height_device = RESOLUTIONHEIGHT_DEVICE;

float wk_lookat_eyex_level = LOOKAT_EYEX_LEVEL;
float wk_lookat_eyey_level = LOOKAT_EYEY_LEVEL;
float wk_lookat_eyez_level = LOOKAT_EYEZ_LEVEL;
float wk_lookat_centerx_level = LOOKAT_CENTERX_LEVEL;
float wk_lookat_centery_level = LOOKAT_CENTERY_LEVEL;
float wk_lookat_centerz_level = LOOKAT_CENTERZ_LEVEL;
float wk_lookat_upvectorx_level = LOOKAT_UPVECTORX_LEVEL;
float wk_lookat_upvectory_level = LOOKAT_UPVECTORY_LEVEL;
float wk_lookat_upvectorz_level = LOOKAT_UPVECTORZ_LEVEL;
// APPEND START FP)K.YAJIMA 2015.02.27
float wk_resolution_width_level = RESOLUTIONWIDTH_LEVEL;
float wk_resolution_height_level = RESOLUTIONHEIGHT_LEVEL;
// APPEND END FP)K.YAJIMA 2015.02.27

GLUI_StaticText* lbl_sending;
GLUI_StaticText* lbl_recieving;
GLUI_StaticText* lbl_smemory;
GLUI_StaticText* lbl_gmemory;
kvs::visclient::Command* g_command;
kvs::glut::Screen* g_screen;
GLUI_EditText* subpixela;
GLUI_EditText* subpixeld;
GLUI_EditText* repeata;
GLUI_EditText* repeatd;
GLUI_EditText* plimit;
GLUI_EditText* pdensity;
GLUI_EditText* crop_cxmin;
GLUI_EditText* crop_cxmax;
GLUI_EditText* crop_cymin;
GLUI_EditText* crop_cymax;
GLUI_EditText* crop_czmin;
GLUI_EditText* crop_czmax;
// tantantan
GLUI_EditText* lookat_eyex;
GLUI_EditText* lookat_eyey;
GLUI_EditText* lookat_eyez;
GLUI_EditText* lookat_centerx;
GLUI_EditText* lookat_centery;
GLUI_EditText* lookat_centerz;
GLUI_EditText* lookat_upvectorx;
GLUI_EditText* lookat_upvectory;
GLUI_EditText* lookat_upvectorz;
GLUI_EditText* resolution_width;
GLUI_EditText* resolution_height;
// tantantan
GLUI_EditText* g_volumedata;    /* for PFI file */
GLUI_Checkbox* norepsampling;

GLUI_StaticText* lbl_numNodes;
GLUI_StaticText* lbl_numElements;
GLUI_StaticText* lbl_elemType;
GLUI_StaticText* lbl_fileType;
GLUI_StaticText* lbl_numIngredients;
GLUI_StaticText* lbl_numStep;
GLUI_StaticText* lbl_numVolDiv;
GLUI_StaticText* lbl_objectCoord0;
GLUI_StaticText* lbl_objectCoord1;
GLUI_StaticText* lbl_objectCoord2;
//kvs::glut::Screen hc;

// APPEND START FP)M.TANAKA 2015.03.16
float g_ro[3][3];
float g_tr[3];
float g_sc[3];
// APPEND END   FP)M.TANAKA 2015.03.16
size_t c_smemory;
