#ifndef EXTENDED_TRANSFER_FUNCTION_H_INCLUDE
#define EXTENDED_TRANSFER_FUNCTION_H_INCLUDE

#include <kvs/ColorMap>
#include <kvs/OpacityMap>
#include "TransferFunction.h"
#include "function.h"
#include "function_op.h"
#include "function_parser.h"
#include "Types.h"

class ExtendedTransferFunction : public pbvr::TransferFunction
{
public:
    int32_t Resolution;
    std::string EquationR;
    std::string EquationG;
    std::string EquationB;
    std::string EquationA;
    float ColorVarMin;
    float ColorVarMax;
    float OpacityVarMin;
    float OpacityVarMax;

public:

    ExtendedTransferFunction();
    ExtendedTransferFunction( const TransferFunction& tf );
    ExtendedTransferFunction( std::string rfstr,
                              std::string gfstr,
                              std::string bfstr,
                              std::string ofstr,
                              const size_t      resolution,
                              const float       min_value,
                              const float       max_value );
    ~ExtendedTransferFunction( void );

};

class NamedTransferFunction : public ExtendedTransferFunction
{
public:
    enum Selection
    {
        SelectExtendTransferFunction = 0,
        SelectTransferFunction = 1,
    };

public:
    Selection selection;

    std::string Name;
    std::string ColorVar;
    std::string OpacityVar;

public:
    NamedTransferFunction() :
        selection( SelectExtendTransferFunction ),
        Name( "" ), ColorVar( "" ), OpacityVar( "" )
    {
    }

    NamedTransferFunction( const TransferFunction& tf ) :
        selection( SelectExtendTransferFunction ),
        Name( "" ), ColorVar( "" ), OpacityVar( "" ),
        ExtendedTransferFunction( tf )
    {
    }
};

#endif // EXTENDED_TRANSFER_FUNCTION_H_INCLUDE
